#!/usr/local/bin/bash


	
function load_driver() {
	local	err

	if [ $OSYSTEM = "Linux" ]; then
		$MODULE_LOAD $1  > /dev/null 
		err=$?
	elif [ $OSYSTEM = "FreeBSD" ]; then
		err=`$MODULE_LOAD $1 >/dev/null`
	elif [ $OSYSTEM = "OpenBSD" -o $OSYSTEM = "NetBSD" ]; then
		err=`$MODULE_LOAD -o $MODULE_DIR/$1.out -e$1 $MODULE_DIR/$1.o  1> /dev/null`
	fi
	return $err
}

function unload_driver () {
	local err

	if [ $OSYSTEM = "OpenBSD" -o $OSYSTEM = "NetBSD" ]; then
		\rm -rf $MODULE_DIR/$1.out
		err=`$MODULE_UNLOAD -n $1 2> /dev/null`
	else
		err=`$MODULE_UNLOAD $1  2> /dev/null` 
		err=`$MODULE_UNLOAD sdladrv  2> /dev/null` 
	fi
	return $err
}


##
CMD=$1
OSYSTEM=`uname -s`
RELEASE=`uname -r`
if [ $OSYSTEM = "Linux" ]; then
	MODULE_STAT=lsmod
	WAN_DRIVERS="wan_aften"
	MODULE_LOAD=modprobe
	MODULE_UNLOAD="modprobe -r"
elif [ $OSYSTEM = "FreeBSD" ]; then

	major_ver=${RELEASE%%.*}
	MODULE_STAT=kldstat
	MODULE_LOAD=kldload
	MODULE_UNLOAD=kldunload
	if [ "$major_ver" = "5" ]; then
		MODULE_DIR=/boot/modules
	else
		MODULE_DIR=/modules
	fi
	WAN_DRIVERS="wan_aften"
elif [ $OSYSTEM = "OpenBSD" ]; then

	MODULE_STAT=modstat
	MODULE_LOAD=modload
	MODULE_UNLOAD=modunload
	MODULE_DIR=/usr/lkm
	WAN_DRIVERS="wan_aften"
elif [ $OSYSTEM = "NetBSD" ]; then

	MODULE_STAT=modstat
	MODULE_LOAD=modload
	MODULE_UNLOAD=modunload
	MODULE_DIR=/usr/lkm
	WAN_DRIVERS="wan_aften"
fi

case "$CMD" in
	load)
		load_driver ${WAN_DRIVERS}
		echo "AFT card enabled!"
		;;
	unload)
		echo "AFT card disabled!"
		unload_driver ${WAN_DRIVERS}
		;;
esac
exit 0
